#!/usr/bin/python3

from functools import partial

from resolution import *

# problème des cruches = couple de deux entiers (G,P)
# en python, un état e = un tuple à deux éléments (e[0],e[1])

def etat_en_texte (e) :
        return str(e)

def remplir_petite (e):
	return (e[0],5)

def precond_remplir_petite (e):
	return (e[1]<5)

def remplir_grande (e):
	return (7,e[1])

def precond_remplir_grande (e):
	return (e[0]<7)

def jeter_petite (e):
	return (e[0],0)

def precond_jeter_petite (e):
	return (e[1]>0)

def jeter_grande (e):
	return (0,e[1])

def precond_jeter_grande (e):
	return (e[0]>0)

def vider_pdg (e):
	return (e[0]+e[1],0)

def precond_vider_pdg (e):
	return ((e[1]>0) and (e[0]+e[1]<=7))

def vider_gdp (e):
	return (0,e[0]+e[1])

def precond_vider_gdp (e):
	return ((e[0]>0) and (e[0]+e[1]<=5))

def completer_petite (e):
	return (e[0]-(5-e[1]),5)

def precond_completer_petite (e):
	return ((e[1]<5) and (e[0]+e[1]>5))

def completer_grande (e):
	return (7,e[1]-(7-e[0]))

def precond_completer_grande (e):
	return ((e[0]<7) and (e[0]+e[1]>7))


# liste des 8 opérateurs pour le problème des cruches
operateurs_disponibles = [
  nouvel_operateur('remplir petite',precond_remplir_petite,remplir_petite),
  nouvel_operateur('remplir grande',precond_remplir_grande,remplir_grande),
  nouvel_operateur('jeter petite',precond_jeter_petite,jeter_petite),
  nouvel_operateur('jeter grande',precond_jeter_grande,jeter_grande),
  nouvel_operateur('vider petite dans grande',precond_vider_pdg,vider_pdg),
  nouvel_operateur('vider grande dans petite',precond_vider_gdp,vider_gdp),
  nouvel_operateur('compléter petite',precond_completer_petite,completer_petite),
  nouvel_operateur('compléter grande',precond_completer_grande,completer_grande),
]


opérateurs_applicables = partial(sélection_opérateurs_applicables,operateurs_disponibles)


# état initial et états finaux
etat_initial = (0,0)

def est_final(e) :
#	return ((e[0]==1) or (e[1]==1)) #  8 étapes
#	return ((e[0]==2) or (e[1]==2)) #  3 étapes
#	return ((e[0]==3) or (e[1]==3)) #  4 étapes
	return ((e[0]==4) or (e[1]==4)) #  6 étapes, sujet td
#	return ((e[0]==6) or (e[1]==6)) # 10 étapes, sujet tp


# APPELS AUX PROCÉDURES DE RECHERCHE

print()

affiche_titre("État initial");
affiche_état(etat_en_texte(etat_initial))
print()

affiche_titre("Objectif")
affiche_but("obtenir 4 litres dans l'une des cruches")
print()

recherche_en_profondeur_limitée (etat_initial,est_final,opérateurs_applicables,etat_en_texte,8)
#recherche_G(etat_initial,est_final,opérateurs_applicables,etat_en_texte,premier)


