
from random import choice


def ValeurFinPartie (id_minmax,id_adversaire,id_gagnant):
    if id_gagnant==id_minmax:
        return +1
    elif id_gagnant==id_adversaire:
        return -1
    else:
        return 0



# Évalue une situation de jeu pour le joueur artificiel (niveau Max)

def ValeurMax (état,id_minmax,id_adversaire,fin_partie,coups_possibles,applique_coup) :
    
    (terminée,gagnant) = fin_partie(état,id_minmax,id_adversaire,True)
    if terminée:
        return ValeurFinPartie(id_minmax,id_adversaire,gagnant)
    else :
        coups     = coups_possibles(état,id_minmax)
        bestScore = -1e99
        for coup in coups:
            nétat = applique_coup(état,id_minmax,coup)
            nscore = ValeurMin(nétat,id_minmax,id_adversaire,fin_partie,coups_possibles,applique_coup)
            if nscore > bestScore:
                bestScore = nscore
        return bestScore


# Évalue une situation de jeu pour le joueur humain (niveau Min)

def ValeurMin (état,id_minmax,id_adversaire,fin_partie,coups_possibles,applique_coup) :
    
    (terminée,gagnant) = fin_partie(état,id_minmax,id_adversaire,False)
    if terminée:
        return ValeurFinPartie(id_minmax,id_adversaire,gagnant)
    else:
        coups     = coups_possibles(état,id_adversaire)
        bestScore = +1e99
        for coup in coups:
            nétat = applique_coup(état,id_adversaire,coup)
            nscore = ValeurMax(nétat,id_minmax,id_adversaire,fin_partie,coups_possibles,applique_coup)
            if nscore < bestScore:
                bestScore = nscore
        return bestScore

    
# Décider du coup à jouer (pour le joueur artificiel) en appliquant l'algorithme MinMax

def DecisionMinMax(état,id_minmax,id_adversaire,fin_partie,coups_possibles,applique_coup) :
    coups     = coups_possibles(état,id_minmax)
    bestScore = -1e99
    bestCoups = []
    for coup in coups:
        nétat = applique_coup(état,id_minmax,coup)
        nscore = ValeurMin(nétat,id_minmax,id_adversaire,fin_partie,coups_possibles,applique_coup)
        if nscore > bestScore:
                bestScore = nscore
                bestCoups = [ coup ]
        elif nscore == bestScore:
            bestCoups.append(coup)
            
    return (choice(bestCoups),bestScore)


